//
//  ShoppingTableViewCell.h
//  Lighting
//
//  Created by 曹云霄 on 16/4/29.
//  Copyright © 2016年 上海勾芒科技有限公司. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ShopcarModel.h"


@protocol ChangeGoodsNumberDelegate <NSObject>

@optional
/**
 *  当前商品数量、成交价
 */
- (void)ChangeGoodsNumber:(int)goodsNumber WithcostPrice:(CGFloat)costprice Withcellindex:(NSInteger)cellindex;


@end






@interface ShoppingTableViewCell : UITableViewCell<UITextFieldDelegate>

/**
 *  选中
 */
@property (weak, nonatomic) IBOutlet UIButton *selectedButton;

/**
 *  商品图片
 */
@property (weak, nonatomic) IBOutlet UIImageView *goodsImageView;

/**
 *  商品信息
 */
@property (weak, nonatomic) IBOutlet UILabel *goodsInformationLabe;

/**
 *  吊牌价格
 */
@property (weak, nonatomic) IBOutlet UILabel *tagsPriceLabe;

/**
 *  成交价格
 */
@property (weak, nonatomic) IBOutlet UITextField *clinchTextfield;


/**
 *  商品数量
 */
@property (weak, nonatomic) IBOutlet UILabel *goodsNumbersLabe;


/**
 *  产品金额
 */
@property (weak, nonatomic) IBOutlet UILabel *productPriceLabe;



/**
 *  数据源model
 */
@property (nonatomic,strong) ShopcarModel *model;


/**
 *  传入cel下标
 */
@property (nonatomic,assign) NSInteger cellindex;


/**
 *  传回选中状态
 */
@property (nonatomic,copy) void(^returnCellblock)(NSInteger index);



/**
 *  成交价背景View
 */
@property (weak, nonatomic) IBOutlet UIView *ClinchPriceBackView;

/**
 *  商品数量
 */
@property (nonatomic,assign) id<ChangeGoodsNumberDelegate>delegate;

/**
 *  提示框回调
 */
@property (nonatomic,copy) void(^promptStringBlock)(NSString *string);

/**
 *  商品规格
 */
@property (weak, nonatomic) IBOutlet UILabel *specifications;

/**
 *  商品代码
 */
@property (weak, nonatomic) IBOutlet UILabel *goodsCode;

@end
